"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Container = void 0;

var Container = function Container(addChild, deleteChild) {
  var inChild = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : addChild;
  var children = [];

  var appendChild = function appendChild(child) {
    children.push(child);
    addChild(child); //if (child.element) child.element.show();
  };

  var insertChild = function insertChild(child, beforeChild) {
    if (!children.includes(beforeChild)) {
      throw new Error("Relative element does not exist");
    }

    var i = children.indexOf(beforeChild);
    children.splice(i, 0, child);
    inChild(child, i, beforeChild); //if (child.element) child.element.show();
  };

  var removeChild = function removeChild(child) {
    if (!children.includes(child)) {
      throw new Error("Can't remove a child that's not added");
    }

    var i = children.indexOf(child);
    children.splice(i, 1);
    deleteChild(child);
  };

  return {
    appendChild: appendChild,
    insertChild: insertChild,
    removeChild: removeChild,
    children: children
  };
};

exports.Container = Container;