"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ = require("../");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _color = _interopRequireDefault(require("color"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TouchableHighlight =
/*#__PURE__*/
function (_Component) {
  _inherits(TouchableHighlight, _Component);

  function TouchableHighlight() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TouchableHighlight);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TouchableHighlight)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "pressedDown", false);

    _defineProperty(_assertThisInitialized(_this), "startedTime", 0);

    _defineProperty(_assertThisInitialized(_this), "state", {
      extraChildStyle: null,
      extraUnderlayStyle: null
    });

    return _this;
  }

  _createClass(TouchableHighlight, [{
    key: "onDown",
    value: function onDown() {
      this.pressedDown = true;
      this.startedTime = new Date().getTime();

      var child = _react["default"].Children.only(this.props.children);

      this.setState({
        extraChildStyle: {
          backgroundColor: (0, _color["default"])(child.props.style.backgroundColor).alpha(this.props.activeOpacity).string()
        },
        extraUnderlayStyle: {
          backgroundColor: this.props.underlayColor
        }
      });
    }
  }, {
    key: "onUp",
    value: function onUp() {
      if (this.pressedDown) {
        var diff = new Date().getTime() - this.startedTime;

        if (diff > 500) {
          this.props.onLongPress ? this.props.onLongPress() : this.props.onPress();
        } else {
          this.props.onPress();
        }

        this.pressedDown = false;
        this.setState({
          extraChildStyle: null,
          extraUnderlayStyle: null
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var child = _react["default"].Children.only(this.props.children);

      return _react["default"].createElement(_.View, _extends({}, this.props, {
        style: _objectSpread({}, this.props.style, {}, this.state.extraUnderlayStyle),
        onResponderGrant: function onResponderGrant() {
          return _this2.onDown();
        },
        onResponderRelease: function onResponderRelease() {
          return _this2.onUp();
        }
      }), _react["default"].cloneElement(child, {
        style: _objectSpread({}, child.props.style, {}, this.state.extraChildStyle)
      }));
    }
  }]);

  return TouchableHighlight;
}(_react.Component);

exports["default"] = TouchableHighlight;

_defineProperty(TouchableHighlight, "defaultProps", {
  activeOpacity: 0.85,
  underlayColor: 'black',
  style: {},
  onPress: function onPress() {},
  onLongPress: function onLongPress() {}
});

_defineProperty(TouchableHighlight, "propTypes", {
  activeOpacity: _propTypes["default"].number,
  underlayColor: _propTypes["default"].string,
  style: _propTypes["default"].object,
  onPress: _propTypes["default"].func,
  onLongPress: _propTypes["default"].func
});