"use strict";

var _module = _interopRequireDefault(require("module"));

var _fileType = _interopRequireDefault(require("file-type"));

var _readChunk = _interopRequireDefault(require("read-chunk"));

var _fs = _interopRequireDefault(require("fs"));

var _imageSize = _interopRequireDefault(require("image-size"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var originalLoader = _module["default"]._load;

_module["default"]._load = function (request, parent) {
  var buffer;

  try {
    buffer = _readChunk["default"].sync(request, 0, _fileType["default"].minimumBytes);
  } catch (_unused) {
    return originalLoader.apply(this, arguments);
  }

  var type = (0, _fileType["default"])(buffer).mime;
  if (type.split('/')[0] != 'image') return originalLoader.apply(this, arguments);
  var size = (0, _imageSize["default"])(request);
  return {
    uri: request,
    width: size.width,
    height: size.height
  };
};